SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[MSU_DI_HOUSE_RIGHTS_SAVE]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[MSU_DI_HOUSE_RIGHTS_SAVE]
GO


CREATE  PROCEDURE [dbo].[MSU_DI_HOUSE_RIGHTS_SAVE]
AS
DECLARE @SQLError    INT,
        @RowCount    INT,
        @comment     VARCHAR(254),
        @EventText   VARCHAR(254),
        @ObjectLink  INT,
        @nLink       INT,
        @LinkCorr    INT,
        @LinkVl      INT,
        @nObj        INT,
		@LinkHouse integer

SET XACT_ABORT ON
BEGIN TRAN

UPDATE #MSU_DI_HOUSE_RIGHTS_SAVE SET LINK_VL = NULL WHERE LINK_VL = 0
UPDATE #MSU_DI_HOUSE_RIGHTS_SAVE SET TYPE_LINK = NULL WHERE TYPE_LINK = 0

IF (SELECT COUNT(*) FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = 1
BEGIN
	SELECT @LinkVl = LINK_VL
	FROM   #MSU_DI_HOUSE_RIGHTS_SAVE
		
	IF (SELECT TYPE_VL FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = '/'
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_DEP = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_DEP = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO, LINK_REG)
			VALUES (1,@LinkVl,NULL,NULL,NULL) 
					
			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN

			    RETURN
			END

			SET @LinkCorr = @@IDENTITY	
		END
	END			
				
	IF (SELECT TYPE_VL FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = '/'
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_PERS = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_PERS = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO, LINK_REG)
			VALUES (2,NULL,@LinkVl,NULL,NULL)
			
			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN
			    
			    RETURN
			END
			
			SET @LinkCorr = @@IDENTITY
		END
	END
	
	IF (SELECT TYPE_VL FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = ''
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_MO = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_MO = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO, LINK_REG)
			VALUES (3,NULL,NULL,@LinkVl,NULL)
			 
			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN
			    
			    RETURN
			END
			
			SET @LinkCorr = @@IDENTITY
		END
	END
	
	IF (SELECT TYPE_VL FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = ''
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_REG = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_REG = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO, LINK_REG)
			VALUES (4,NULL,NULL,NULL,@LinkVl)
			
			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN
			    
			    RETURN
			END
			
			SET @LinkCorr = @@IDENTITY
		END
	END
						
	--      ,      , 
	--    ,  .   ,      .   ).
	IF (SELECT TYPE_VL FROM #MSU_DI_HOUSE_RIGHTS_SAVE) = ''
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE KOR_TYP = 5)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  KOR_TYP = 5
		END
			ELSE 
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO, LINK_REG)
			VALUES (5,NULL,NULL,NULL,NULL) 
			
			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN
			    
			    RETURN
			END
			
			SET @LinkCorr = @@IDENTITY
		END
	END
	
	-- 
	DECLARE @dtDateBegin  DATETIME,
	        @dtDateEnd    DATETIME,
	        @nLinkType    INT
	
	SELECT @dtDateBegin = DATE_RIGHTS,
	       @dtDateEnd = DATE_END2,
	       @nLinkType = TYPE_LINK
	FROM   #MSU_DI_HOUSE_RIGHTS_SAVE
	
	--      
	IF (@dtDateEnd < @dtDateBegin)
	BEGIN
	    RAISERROR('#MSG#          !  !',16,1)
	    ROLLBACK TRAN
	    RETURN
	END

	--    
	IF (ISNULL(@nLinkType, 0) <= 0)
	BEGIN
	    RAISERROR('#MSG#    !  !',16,1)
	    ROLLBACK TRAN
	    RETURN
	END
	
	--    
	if exists(select * from #Msu_Di_House_Rights_Save where Znam = 0 or isnull(Chisl,1) > isnull(Znam,1))
	begin
	    raiserror('#MSG#        1!  !',16,1)
	    rollback tran
	    return
	end
	
	--   
	if exists(
		select top 1 * from
		(select
			[Link]		= mdhr.Link
			,[Summ]		= sum(cast(mhr.Part_Chisl as float)/cast(mhr.Part_Znam as float)) 
			+ (select sum(cast(mdlr2.Chisl as float)/cast(mdlr2.Znam as float)) from #Msu_Di_House_Rights_Save mdlr2 where mdlr2.Link = mdhr.Link)  
		from #Msu_Di_House_Rights_Save mdhr
		inner join dbo.Msu_Rigths_Type mrt on mrt.Link = mdhr.Type_Link and mrt.Code in ('001001001000', '001001002000')
		inner join dbo.Msu_Houses_Rights mhr on mhr.Link_House = mdhr.Link_House and not mhr.Link = mdhr.Link
			and ((isnull(mdhr.date_rights, convert(datetime, '19000101', 121)) < isnull(mhr.date_end2, convert(datetime, '29990101', 121))
			and isnull(mhr.date_rights, convert(datetime, '19000101', 121)) < isnull(mdhr.date_end2, convert(datetime, '29990101', 121)))
			and not( mhr.date_rights is null and mhr.date_end2 is null) and not (mdhr.date_rights is null and mdhr.date_end2 is null)
			)

		inner join dbo.Msu_Rigths_Type mrt2 on mrt2.Link = mhr.Link_Type and mrt2.Code in ('001001001000', '001001002000')
		group by mdhr.Link) s
		where s.Summ > 1)
	begin
	    raiserror('#MSG#       1!  !      ,     ,   [  ].',16,1)
	    rollback tran
	    return
	end
	
	IF EXISTS(SELECT * FROM #MSU_DI_HOUSE_RIGHTS_SAVE WHERE LINK <= 0)  
	BEGIN
		-- before insert check some.
		-- 1.don't save if house is belong to this FL.

		INSERT INTO dbo.MSU_HOUSES_RIGHTS WITH(ROWLOCK)(
		       LINK_HOUSE,
		       LINK_TYPE,
		       LINK_KORR,
		       PART_CHISL,
		       PART_ZNAM,
		       DATE_RIGHTS,
		       DATE_END2,
		       COMMENT)
		SELECT LINK_HOUSE,
		       TYPE_LINK,
		       @LinkCorr,
		       CHISL,
		       ZNAM,
		       DATE_RIGHTS,
		       DATE_END2,
		       COMMENT
		FROM   #MSU_DI_HOUSE_RIGHTS_SAVE
		WHERE  LINK <= 0
				
		IF @@error != 0
		BEGIN
		    IF @@trancount > 0
		        ROLLBACK TRAN
		    
		    RETURN
		END
		
		SET @nLink = @@IDENTITY
	END

	IF EXISTS(SELECT * FROM #MSU_DI_HOUSE_RIGHTS_SAVE WHERE LINK>0) 
	BEGIN
		SELECT @nLink = LINK
		FROM   #MSU_DI_HOUSE_RIGHTS_SAVE

		UPDATE D
		SET    D.LINK_HOUSE = C.LINK_HOUSE,
		       D.LINK_TYPE = C.TYPE_LINK,
		       D.LINK_KORR = @LinkCorr,
		       D.PART_CHISL = C.CHISL,
		       D.PART_ZNAM = C.ZNAM,
		       D.DATE_RIGHTS = C.DATE_RIGHTS,
		       D.DATE_END2 = C.DATE_END2,
		       D.COMMENT = C.COMMENT
		FROM   #MSU_DI_HOUSE_RIGHTS_SAVE C,
		       MSU_HOUSES_RIGHTS D
		WHERE  D.LINK = C.LINK
		
		IF @@error != 0
		BEGIN
		    IF @@trancount > 0
		        ROLLBACK TRAN
		    
		    RETURN
		END
	END

	SELECT @nObj = dbo.obj_id('MSU_DI_HOUSES')		

	IF OBJECT_ID('tempdb..#MSU_DI_DOC_RIGHTS_SAVE') IS NOT NULL
	BEGIN
	    EXEC MSU_DI_DOC_RIGHTS_SAVE @nLink, @nObj
	END
		
	SELECT @nLink AS LINK
	
	IF OBJECT_ID('tempdb..#MSU_DI_DOC_RIGHTS_SAVE') IS NOT NULL
	BEGIN
	    SELECT [UID],
	           LINK
	    FROM   #MSU_DI_DOC_RIGHTS_SAVE
	    WHERE  [UID] <> 0 AND
	           [UID] IS NOT NULL
	END 
	
	set @LinkHouse=(select link_house from #msu_di_house_rights_save)
	if exists(select * from dbo.msu_houses_rights where link_type in(select link from dbo.msu_rigths_type where code in('001001006000','001001007000','001001001000','001001002000','001001003000')) and link_house=@LinkHouse)
		update dbo.msu_houses
			set sign_stateful=1
		where link=@LinkHouse	


	IF @@trancount > 0
	    COMMIT TRAN
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[MSU_DI_LAND_RIGHTS_SAVE]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[MSU_DI_LAND_RIGHTS_SAVE]
GO

CREATE PROCEDURE [dbo].[MSU_DI_LAND_RIGHTS_SAVE]
AS
DECLARE @SQLError     INT,
        @RowCount     INT,
        @comment      VARCHAR(254),
        @EventText    VARCHAR(254),
        @ObjectLink   INT,
        @nLink        INT,
        @LinkCorr     INT,
        @LinkVl       INT,
        @nObj         INT,
        @LinkLand integer		

SET XACT_ABORT ON
BEGIN TRAN

UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET LINK_VL = NULL WHERE LINK_VL = 0
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE_LINK = NULL WHERE TYPE_LINK = 0
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE=1 WHERE TYPE_VL='/'
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE=2 WHERE TYPE_VL='/'
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE=3 WHERE TYPE_VL=''
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE=4 WHERE TYPE_VL=''
UPDATE #MSU_DI_LAND_RIGHTS_SAVE SET TYPE=5 WHERE TYPE_VL=''

IF (SELECT COUNT(*) FROM #MSU_DI_LAND_RIGHTS_SAVE) = 1
BEGIN 
	SELECT @LinkVl = LINK_VL
	FROM   #MSU_DI_LAND_RIGHTS_SAVE

	IF (SELECT [TYPE] FROM #MSU_DI_LAND_RIGHTS_SAVE) = 1
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_DEP = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_DEP = @LinkVl
		END
			ELSE 
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO,LINK_REG)
			VALUES (1,@LinkVl,NULL,NULL,NULL)

			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN

			    RETURN
			END

			SET @LinkCorr = @@IDENTITY
		END
	END

	IF (SELECT [TYPE] FROM #MSU_DI_LAND_RIGHTS_SAVE) = 2
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_PERS = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_PERS = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO,LINK_REG)
			VALUES (2,NULL,@LinkVl,NULL,NULL)

			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN

			    RETURN
			END

			SET @LinkCorr = @@IDENTITY
		END	
	END

	IF (SELECT [TYPE] FROM #MSU_DI_LAND_RIGHTS_SAVE) = 3
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_MO = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_MO = @LinkVl
		END
			ELSE
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO,LINK_REG)
			VALUES (3,NULL,NULL,@LinkVl,NULL)

			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN

			    RETURN
			END

			SET @LinkCorr = @@IDENTITY	
		END	
	END

	IF (SELECT [TYPE] FROM #MSU_DI_LAND_RIGHTS_SAVE) = 4
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE LINK_REG = @LinkVl)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  LINK_REG = @LinkVl
		END
			ELSE 
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO,LINK_REG)
			VALUES (4,NULL,NULL,NULL,@LinkVl)

			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN
			    
			    RETURN
			END

			SET @LinkCorr = @@IDENTITY	
		END	
	END

	IF (SELECT [TYPE] FROM #MSU_DI_LAND_RIGHTS_SAVE) = 5
	BEGIN
		IF EXISTS(SELECT LINK FROM MSU_KORRESPONDENTS WHERE KOR_TYP = 5)
		BEGIN
			SELECT @LinkCorr = LINK
			FROM   MSU_KORRESPONDENTS
			WHERE  KOR_TYP = 5
		END
			ELSE 
		BEGIN
			INSERT INTO MSU_KORRESPONDENTS (KOR_TYP,LINK_DEP,LINK_PERS,LINK_MO,LINK_REG)
			VALUES (5,NULL,NULL,NULL,NULL)

			IF @@error != 0
			BEGIN
			    IF @@trancount > 0
			        ROLLBACK TRAN

			    RETURN
			END

			SET @LinkCorr = @@IDENTITY
		END
	END

	-- 
	DECLARE @dtDateBegin  DATETIME,
	        @dtDateEnd    DATETIME,
	        @nLinkType    INT
	
	SELECT @dtDateBegin = DATE_RIGHTS,
	       @dtDateEnd = DATE_END2,
	       @nLinkType = TYPE_LINK
	FROM   #MSU_DI_LAND_RIGHTS_SAVE
	
	--      
	IF (@dtDateEnd < @dtDateBegin)
	BEGIN
	    RAISERROR('#MSG#          !  !',16,1)
	    ROLLBACK TRAN
	    RETURN
	END

	--    
	IF (ISNULL(@nLinkType, 0) <= 0)
	BEGIN
	    RAISERROR('#MSG#    !  !',16,1)
	    ROLLBACK TRAN
	    RETURN
	END

	--    
	if exists(select * from #Msu_Di_Land_Rights_Save where Znam = 0 or isnull(Chisl,1) > isnull(Znam,1))
	begin
	    raiserror('#MSG#        1!  !',16,1)
	    rollback tran
	    return
	end
	
	--   
	if exists(
		select top 1 * from
		(select
			[Link]		= mdlr.Link
			,[Summ]		= sum(cast(mlr.Part_Chisl as float)/cast(mlr.Part_Znam as float)) 
			+ (select sum(cast(mdlr2.Chisl as float)/cast(mdlr2.Znam as float)) from #Msu_Di_Land_Rights_Save mdlr2 where mdlr2.Link = mdlr.Link)  
		from #Msu_Di_Land_Rights_Save mdlr
		inner join dbo.Msu_Rigths_Type mrt on mrt.Link = mdlr.Type_Link and mrt.Code in ('001001001000', '001001002000')
		inner join dbo.Msu_Land_Rights mlr on mlr.Link_Land = mdlr.Link_Land and not mlr.Link = mdlr.Link 
			and ((isnull(mdlr.date_rights, convert(datetime, '19000101', 121)) < isnull(mlr.date_end2, convert(datetime, '29990101', 121))
			and isnull(mlr.date_rights, convert(datetime, '19000101', 121)) < isnull(mdlr.date_end2, convert(datetime, '29990101', 121)))
			and not( mlr.date_rights is null and mlr.date_end2 is null) and not (mdlr.date_rights is null and mdlr.date_end2 is null)
			)
		inner join dbo.Msu_Rigths_Type mrt2 on mrt2.Link = mlr.Link_Type and mrt2.Code in ('001001001000', '001001002000')
		group by mdlr.Link) s
		where s.Summ > 1)
	begin
	    raiserror('#MSG#       1!  !      ,     ,   [  ].',16,1)
	    rollback tran
	    return
	end
	
	IF EXISTS(SELECT * FROM #MSU_DI_LAND_RIGHTS_SAVE WHERE LINK <= 0)
	BEGIN
		-- before insert check some.
		-- 1.don't save if land is belong to this FL.

		INSERT INTO dbo.MSU_LAND_RIGHTS WITH(ROWLOCK)(
		       LINK_LAND,
		       LINK_TYPE,
		       LINK_KORR,
		       PART_CHISL,
		       PART_ZNAM,
		       DATE_RIGHTS,
		       DATE_END2,
		       COMMENT)
		SELECT LINK_LAND,
		       TYPE_LINK,
		       @LinkCorr,
		       CHISL,
		       ZNAM,
		       DATE_RIGHTS,
		       DATE_END2,
		       COMMENT
		FROM   #MSU_DI_LAND_RIGHTS_SAVE
		WHERE  LINK <= 0

		IF @@error != 0
		BEGIN
		    IF @@trancount > 0
		        ROLLBACK TRAN

		    RETURN
		END

		SET @nLink = @@IDENTITY
	END

	IF EXISTS(SELECT * FROM #MSU_DI_LAND_RIGHTS_SAVE WHERE LINK>0)
	BEGIN
		SELECT @nLink = LINK
		FROM   #MSU_DI_LAND_RIGHTS_SAVE

		UPDATE D
		SET    D.LINK_LAND = C.LINK_LAND,
		       D.LINK_TYPE = C.TYPE_LINK,
		       D.LINK_KORR = @LinkCorr,
		       D.PART_CHISL = C.CHISL,
		       D.PART_ZNAM = C.ZNAM,
		       D.DATE_RIGHTS = C.DATE_RIGHTS,
		       D.DATE_END2 = C.DATE_END2,
		       D.COMMENT = C.COMMENT
		FROM   #MSU_DI_LAND_RIGHTS_SAVE C,
		       MSU_LAND_RIGHTS D
		WHERE  D.LINK = C.LINK
		
		IF @@error != 0
		BEGIN
		    IF @@trancount > 0
		        ROLLBACK TRAN
		    
		    RETURN
		END
	END

	SELECT @nObj = dbo.obj_id('MSU_DI_LANDS')

	IF OBJECT_ID('tempdb..#MSU_DI_DOC_RIGHTS_SAVE') IS NOT NULL
	BEGIN
	    EXEC MSU_DI_DOC_RIGHTS_SAVE @nLink, @nObj
	END

	SELECT @nLink AS LINK

	IF OBJECT_ID('tempdb..#MSU_DI_DOC_RIGHTS_SAVE') IS NOT NULL
	BEGIN
		SELECT [UID],
		       LINK
		FROM   #MSU_DI_DOC_RIGHTS_SAVE
		WHERE  [UID] <> 0 AND
		       [UID] IS NOT NULL
	END
	
	set @LinkLand=(select link_land from #msu_di_land_rights_save)
	if exists(select * from dbo.msu_land_rights where link_type in(select link from dbo.msu_rigths_type where code in('001001006000','001001007000','001001001000','001001002000','001001003000')) and link_land=@LinkLand)
	update dbo.msu_lands
		set sign_stateful=1
	where link=@LinkLand
	
	if @@trancount > 0
	    commit tran
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



EXEC GP

GO
